﻿; 2STL.lsp v.1.0 (C)2017 arch. G.M.Seregni - nov.2017
(setvar "CMDECHO" 0)(command "_setvar" "MODEMACRO" "Starting 2STL")
(setq count 0 lcount 0 cm (chr 34) file (getvar "DWGNAME") lenfile (strlen file))
(setq percorso (getvar "DWGPREFIX") lenpath (strlen percorso))
(if (= (substr file 1 lenpath) percorso); se nomefile comprende percorso
     (setq file (substr file (+ 1 lenpath)(- lenfile lenpath)))
);togli il percorso dal nome
(setq lenfile (strlen file) punta 1 tipo "noest")
(while (<= punta lenfile); mentre il puntatore al carattere è minore o uguale alla lungh. del file
 (if (= (substr file punta 1) "."); se trova un punto
   (progn (setq tipo "siest")(setq pospunto punta)))
 (setq punta (+ 1 punta)) ; incrementa sempre
)  ;end while
(if (= tipo "siest"); se c'e' il punto
     (setq filename (substr file 1 (- pospunto 1))) (setq filename file)
) ;  pulito dall'eventuale estensione 
(command "mslide" "c:\\CadExt\\TMP_STL")(setvar "CMDECHO" 1)
(setq bln_UserClick nil dlg (load_dialog "stl"))
(new_dialog "stlparse" dlg "  ")
(setq x (dimx_tile "tile_Preview") y (dimy_tile "tile_Preview"))
(start_image "tile_Preview")
(fill_image 0 0 x y 1)
(slide_image 0 0 x y "C:\\CadExt\\TMP_STL.sld")
(end_image)
(action_tile "cancel" "(done_dialog)(setq UserClick 0)")
(action_tile "accept" "(done_dialog)(setq UserClick 1)")
(start_dialog)
(if (= UserClick 0) ; NO
  (progn
   (setvar "CMDECHO" 0)(command "setvar" "MODEMACRO" (strcat filename ".dwg parser aborted."))(setvar "CMDECHO" 1)
   (prompt "\nAborted.")
  )
  (progn ;   procedure comuni
   (Defun setAxAyAz() (setq pntA (cdr(assoc 10 alist)) Ax (car pntA) Ay (cadr pntA) Az (caddr pntA)))
   (Defun setBxByBz() (setq pntB (cdr(assoc 11 alist)) Bx (car pntB) By (cadr pntB) Bz (caddr pntB)))
   (Defun setCxCyCz() (setq pntC (cdr(assoc 12 alist)) Cx (car pntC) Cy (cadr pntC) Cz (caddr pntC)))
   (Defun setDxDyDz() (setq pntD (cdr(assoc 13 alist)) Dx (car pntD) Dy (cadr pntD) Dz (caddr pntD)))
   (Defun setp1()     (setq p1 (strcat (rtos Ax) " " (rtos Ay) " " (rtos Az))))
   (Defun swab()      (setq tmp ax ax bx bx tmp tmp ay ay by by tmp tmp az az bz bz tmp))
   (Defun swac()      (setq tmp ax ax cx cx tmp tmp ay ay cy cy tmp tmp az az cz cz tmp))
   (Defun swad()      (setq tmp ax ax dx dx tmp tmp ay ay dy dy tmp tmp az az dz dz tmp))
   (Defun swbc()      (setq tmp bx bx cx cx tmp tmp by by cy cy tmp tmp bz bz cz cz tmp))
   (Defun swbd()      (setq tmp bx bx dx dx tmp tmp by by dy dy tmp tmp bz bz dz dz tmp))
   (Defun swcd()      (setq tmp cx cx dx dx tmp tmp cy cy dy dy tmp tmp cz cz dz dz tmp))
  )
)
(if (= UserClick 1) ;STL
  (progn
      ;######################## ENTITIES SCAN ####
      (setq selez(ssget))
      (if (/= nil selez)
            (progn
               (setvar "CMDECHO" 1)        ;status bar
               (princ "2STL is running!")
               (setq user (getenv "username"))
               (setq filepov (strcat "C:\\Users\\" user "\\Desktop\\" filename ".STL"))(setq fil (open filepov "w"))
               (write-line "solid 2STL_V_1_0" fil)
               (prompt (strcat "\n WRITING " filepov))  (setvar "CMDECHO" 0)
               (setq max (sslength selez) contasel 0 contastl 0)
               (while (> max contasel)
                   (setq en (ssname selez contasel) alist (entget en))
                   (if (= "3DFACE" (cdr(assoc 0 alist)))
                        (progn
                           (setq Tri 0) (setAxAyAz)(setBxByBz)(setCxCyCz)(setDxDyDz)
                           (if (and (= Az Bz)(= Cz Dz)) (progn (swbc)(swac)(swcd)))
                           (if (< Az Bz) (progn (swab)(swcd)))
                           (if (> Bx Cx) (progn 
                                             (swad)  ; 1(a)  4(d)
                                             (swbc)  ; 2(b)  3(c)
                                          ) 
                           )
                           (if (and (= Bx Cx)(> By Cy)) (progn
                                                           (swad)  ; 1(a)  4(d)
                                                           (swbc)  ; 2(b)  3(c)
                                                        )
                           )
                           (setp1)
                           (setq Sbx (rtos Bx) Scx (rtos Cx) Sdx (rtos Dx) Sby (rtos By) Scy (rtos Cy) Sdy (rtos Dy) Sbz (rtos Bz) Scz (rtos Cz) Sdz (rtos Dz))
                           (setq p2 (strcat Sbx" "Sby" "Sbz)  p3 (strcat Scx" "Scy" "Scz) p4 (strcat Sdx" "Sdy" "Sdz))
                           (if (= p1 p4)(setq Tri 1))
                           (if (= p1 p2)(setq p1 p4 Tri 1))
                           (if (= p2 p3)(setq p3 p4 Tri 1))
                           (if (= p3 p4)(setq Tri 1))
                           (if (= Tri 1)
                               (progn
                                  (write-line (strcat " facet normal 0 0 0") fil)  
                                  (write-line (strcat "  outer loop") fil)
                                  (write-line (strcat "   vertex " p1) fil) (write-line (strcat "   vertex " p2) fil) (write-line (strcat "   vertex " p3) fil)
                                  (write-line (strcat "  endloop") fil)
                                  (write-line (strcat " endfacet") fil)
                               )
                               (progn ;else Tri
                                  (write-line (strcat " facet normal 0 0 0") fil)  
                                  (write-line (strcat "  outer loop") fil)
                                  (write-line (strcat "   vertex " p1) fil) (write-line (strcat "   vertex " p2) fil) (write-line (strcat "   vertex " p3) fil)
                                  (write-line (strcat "  endloop") fil)
                                  (write-line (strcat " endfacet") fil)
                                  (write-line (strcat " facet normal 0 0 0") fil)  
                                  (write-line (strcat "  outer loop") fil)
                                  (write-line (strcat "   vertex " p3) fil) (write-line (strcat "   vertex " p4) fil) (write-line (strcat "   vertex " p1) fil)
                                  (write-line (strcat "  endloop") fil)
                                  (write-line (strcat " endfacet") fil)
                               ) ; close progn else Tri
                           ) ; close IF Tri
                           (setq contastl (+ 1 contastl)) 
                      ) ; close progn if 3DFACE
                   ) ; close if 3DFACE
                   (setq contasel (+ 1 contasel))
                   (command "setvar" "MODEMACRO" (strcat " Loaded "(itoa(fix contastl))" entities of "(itoa(fix contasel))" processed."))
               ); end while entities 
               (write-line "endsolid 2STL_V_1_0" fil)
               (startapp "C:\\Program Files\\VCG\\MeshLab\\meshlab.exe" filepov) 
               ;(startapp "C:\\Program Files (x86)\\VCG\\MeshLabOld\\meshlab_32.exe" filepov)
               (prompt "\n") (close fil) (prompt (strcat " " filename ".STL created succesfully."))

          ) ; close progn if no nil
      ) ; close if no nil
    ) ;end progn
  )  ;end if = 1

